#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "Jonkers.h"

ptr Memory, Free;

const ptr Null = 0;

unsigned is_raw(ptr P)
  { return (signed)P < 0; }

unsigned size(ptr P)
  { return abs((signed)P); }

ptr stretch(unsigned U)
  { return (ptr)((unsigned long)U - 1); }

void unmark(ptr P)
  { P->F = u; }
  
static cel memory[100];

static cel make_chunk(unsigned size)
  { cel C = (cel){ Free, u };
    *Free++ = (cel){ (ptr)(unsigned long)size, u };
    for ( ; size ; size--)
      *Free++ = (cel){ Null, a };
    return C; }

static void chunk_set(cel chunk, unsigned offset, cel value)
  { assert(chunk.F == u);
    *(chunk.P + offset + 1) = value; }

static cel chunk_get(cel chunk, unsigned offset)
  { assert(chunk.F == u);
    return *(chunk.P + offset + 1); }

static void show(char* Text)
  { printf("%s:\n", Text);
    for (ptr p = Memory; p < Free; p += 1)
      printf("\n   *0x%4x = [ 0x%4x , %d ]", (unsigned)p, (unsigned)p->P, p->F);
    printf("\n\n"); }

int main(int argc, const char * argv[])
  { cel r1, r2, r3;
    Memory = memory;
    Free = memory + 1;
    make_chunk(0);
    r1 = make_chunk(1);
    make_chunk(2);
    r2 = make_chunk(3);
    make_chunk(1);
    r3 = make_chunk(2);
    chunk_set(r1, 0, r2);
    chunk_set(r2, 0, r1);
    chunk_set(r2, 1, r3);
    chunk_set(r2, 2, r2);
    chunk_set(r3, 0, r2);
    chunk_set(r3, 1, r1);
    show("init");
    Jonkers_mark_thread(r1);
    show("mark-thread");
    Jonkers_unthread();
    show("unthread");
    Jonkers_compact();
    show("compact");
    return 0; }
